import { useReducer } from 'react';

const updateList = (list, action) => {
  switch (action.type) {
    case 'update': {
      const newList = [...list];
      newList[Number(action.item.id)] = action.item;
      return newList;
    }
    case 'refresh':
    default:
      return [];
  }
};

const useList = (initialValue) => useReducer(updateList, initialValue ?? []);

export default useList;
