const { ethers } = require('hardhat');
const fs = require('fs');

const contractAddresses = require('../../contract-addresses.json');
const writeContractAddresses = require('./write-contract-addresses');

require('dotenv').config();

const network = process.env.HARDHAT_NETWORK;

const deployContract = async (name, args = []) => {
  const contract = await ethers.deployContract(name, args);
  await contract.waitForDeployment();
  console.log(`${name} deployed to ${contract.target}`);
  contractAddresses[network][name] = contract.target;

  const from = `./artifacts/contracts/${name}.sol/${name}.json`;
  const to = `../client/src/assets/${name}.json`;
  fs.copyFileSync(from, to);
  console.log(`Copied ${fs.realpathSync(from)} to ${fs.realpathSync(to)}`);

  writeContractAddresses(contractAddresses);
};

module.exports = deployContract;
